"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  ServiceContext: () => ServiceContext,
  isErrorResponse: () => isErrorResponse,
  queryKey: () => queryKey,
  queryOptions: () => queryOptions,
  useServiceContext: () => useServiceContext,
  useServiceMutation: () => useServiceMutation,
  useServiceQuery: () => useServiceQuery
});
module.exports = __toCommonJS(src_exports);

// src/types.ts
function isErrorResponse(error) {
  return error.code !== void 0;
}

// src/useServiceMutation.ts
var import_react_query = require("@tanstack/react-query");
var import_react = require("react");
function useServiceMutation(method, options) {
  const reqCtx = (0, import_react.useContext)(ServiceContext);
  return (0, import_react_query.useMutation)({
    ...options,
    mutationFn: (req) => {
      const resp = method(req, {
        ...reqCtx,
        headers: {
          "Content-Type": "application/json",
          ...reqCtx.headers
        }
      });
      return resp;
    }
  });
}

// src/useServiceQuery.ts
var import_react_query2 = require("@tanstack/react-query");
var import_react2 = require("react");

// src/queryKey.ts
function queryKey(method, req) {
  if (req === void 0)
    return [method.name];
  return [method.name, req];
}

// src/useServiceQuery.ts
function useServiceQuery(method, req, options) {
  const reqCtx = (0, import_react2.useContext)(ServiceContext);
  return (0, import_react_query2.useQuery)(queryOptions(method, req, reqCtx, options));
}
function queryOptions(method, req, reqInit, options) {
  return {
    ...options,
    queryKey: options?.queryKey ?? queryKey(method, req),
    queryFn: () => {
      const resp = method(req, {
        ...reqInit,
        headers: {
          "Content-Type": "application/json",
          ...reqInit?.headers
        }
      });
      if (options?.onError) {
        return resp.catch(options.onError);
      }
      return resp;
    }
  };
}

// src/serviceContext.ts
var import_react3 = require("react");
var ServiceContext = (0, import_react3.createContext)({});
var useServiceContext = () => {
  return (0, import_react3.useContext)(ServiceContext);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ServiceContext,
  isErrorResponse,
  queryKey,
  queryOptions,
  useServiceContext,
  useServiceMutation,
  useServiceQuery
});
//# sourceMappingURL=index.cjs.map